-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name and the namespace table.
local addon, npcg = ...

local functua 	= npcg.functua
local util 			= npcg.functua.util

local generator = { }
local data = { }
local tests = { }

-- generators and data do not exist yet
npcg.generators.age	= generator
npcg.data.age				= data
npcg.tests.age			= tests

local inc = util.getIncremental(1)

local ages = { }	-- Redo this to depending on race.
ages[       "child"] = { tags = {     "minor" }, sortOrder = inc() }
ages[        "teen"] = { tags = { "workforce" }, sortOrder = inc() }
ages[ "young adult"] = { tags = { "workforce" }, sortOrder = inc() }
ages[       "adult"] = { tags = { "workforce" }, sortOrder = inc() }
ages["mature adult"] = { tags = { "workforce" }, sortOrder = inc() }
ages[       "elder"] = { tags = { "workforce" }, sortOrder = inc() }
ages[         "old"] = { tags = { "workforce" }, sortOrder = inc() }
ages[   "venerable"] = { tags = { "workforce" }, sortOrder = inc() }

-- generateRandomAge :: Race a => a -> Age
function generateRandomAge(characterTemplate)
  return util.randomFrom(
    util.eitherOr(
      characterTemplate:getRace()   	== "forsaken" 		or -- Make this teen
				characterTemplate:getRace() 	== "death knight" or
				characterTemplate:getRace() 	== "illidari" 		or
				characterTemplate:getRace() 	== "void elf" 		or
				characterTemplate:getTribe()	== "lightforged", 
      
			data.olderThan("young adult"),
      functua.keys(ages)
    )
  ) or ""
end

-- What are these doing here?!
-- keysBy :: (a -> k) -> { b, a } -> { k, b }
local function keysBy(sortF, xs)
  local output = { }
  
  for k,v in pairs(xs) do
    output[sortF(v)] = k
  end
  return output
end

-- olderThan :: Age -> { Age }
-- Returns all ages older than a given age (including the given age).
function data.olderThan(age)
  return functua.skipWhile(function(x) return x == age end, keysBy(function(v) return v.sortOrder end, ages))
end

-- youngerThan :: Age -> { Age }
function data.youngerThan(age)
  return functua.takeWhile(function(x) return x == age end, keysBy(function(v) return v.sortOrder end, ages))
end

-- agesBetween :: Age -> { Age }
function data.agesBetween(min, max)
  local output = functua.skipWhile(function(x) return x == min end, data.youngerThan(max))
  table.insert(output, max)
  return output
end

-- End of File